package de.intevation.flys.jfree;

import java.util.Collections;
import java.util.List;

import org.w3c.dom.Document;

import org.jfree.chart.annotations.XYTextAnnotation;

import de.intevation.flys.jfree.StickyAxisAnnotation;

import de.intevation.flys.artifacts.model.HYKFactory;


/**
 * List of Text- Annotations with name and theme.
 */
public class FLYSAnnotation {

    // TODO this will likely be used, soon.
    protected List<XYTextAnnotation> textAnnotations;

    protected List<StickyAxisAnnotation> axisTextAnnotations;

    protected List<HYKFactory.Zone> boxes;

    protected Document theme;

    protected String label;


    public FLYSAnnotation(String label, List<StickyAxisAnnotation> annotations) {
        this(label, annotations, null, null);
    }


    /** Create annotations, parameter might be null. */
    public FLYSAnnotation(String label, List<StickyAxisAnnotation> annotations,
        List<HYKFactory.Zone> bAnnotations
    ) {
        this(label, annotations, bAnnotations, null);
    }


    /** Create annotations, parameter might be null. */
    public FLYSAnnotation(String label, List<StickyAxisAnnotation> annotations,
        List<HYKFactory.Zone> bAnnotations, Document theme
    ) {
        this.label           = label;
        this.axisTextAnnotations = (annotations != null)
                               ? annotations
                               : Collections.<StickyAxisAnnotation>emptyList();
        this.boxes  = (bAnnotations != null)
                               ? bAnnotations
                               : Collections.<HYKFactory.Zone>emptyList();
        this.textAnnotations = Collections.<XYTextAnnotation>emptyList();
        this.setTheme(theme);
    }


    public void setLabel(String label) {
        this.label = label;
    }

    public String getLabel() {
        return label;
    }

    public List<StickyAxisAnnotation> getAxisTextAnnotations() {
        return axisTextAnnotations;
    }

    public List<XYTextAnnotation> getTextAnnotations() {
        return textAnnotations;
    }

    public List<HYKFactory.Zone> getBoxes() {
        return boxes;
    }

    public void setTheme(Document theme) {
        this.theme = theme;
    }

    public Document getTheme() {
        return theme;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
